Winspool (JNA API)

com.sun.jna.platform.win32

## Interface Winspool

- All Superinterfaces:
    AltCallingConvention, Library, StdCall, StdCallLibrary

      public interface Winspool
      extends StdCallLibrary

  Ported from Winspool.h. Windows SDK 6.0a
  Author:
    dblock[at]dblock.org

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `Winspool.JOB_INFO_1` The JOB_INFO_1 structure specifies print-job information such as the job-identifier value, the name of the printer for which the job is spooled, the name of the machine that created the print job, the name of the user that owns the print job, and so on.
    `static class` | `Winspool.LPPRINTER_DEFAULTS` The PRINTER_DEFAULTS structure specifies the default data type, environment, initialization data, and access rights for a printer.
    `static class` | `Winspool.PRINTER_INFO_1` The PRINTER_INFO_1 structure specifies general printer information.
    `static class` | `Winspool.PRINTER_INFO_2` The PRINTER_INFO_2 structure specifies detailed printer information.
    `static class` | `Winspool.PRINTER_INFO_4` The PRINTER_INFO_4 structure specifies general printer information.

    - ### Nested classes/interfaces inherited from interface com.sun.jna.win32.StdCallLibrary

      `StdCallLibrary.StdCallCallback`

    - ### Nested classes/interfaces inherited from interface com.sun.jna.Library

      `Library.Handler`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `CCHDEVICENAME`
    `static Winspool` | `INSTANCE`
    `static int` | `PRINTER_ATTRIBUTE_DEFAULT`
    `static int` | `PRINTER_ATTRIBUTE_DIRECT`
    `static int` | `PRINTER_ATTRIBUTE_DO_COMPLETE_FIRST`
    `static int` | `PRINTER_ATTRIBUTE_ENABLE_BIDI`
    `static int` | `PRINTER_ATTRIBUTE_ENABLE_DEVQ`
    `static int` | `PRINTER_ATTRIBUTE_FAX`
    `static int` | `PRINTER_ATTRIBUTE_FRIENDLY_NAME`
    `static int` | `PRINTER_ATTRIBUTE_HIDDEN`
    `static int` | `PRINTER_ATTRIBUTE_KEEPPRINTEDJOBS`
    `static int` | `PRINTER_ATTRIBUTE_LOCAL`
    `static int` | `PRINTER_ATTRIBUTE_MACHINE`
    `static int` | `PRINTER_ATTRIBUTE_NETWORK`
    `static int` | `PRINTER_ATTRIBUTE_PUBLISHED`
    `static int` | `PRINTER_ATTRIBUTE_PUSHED_MACHINE`
    `static int` | `PRINTER_ATTRIBUTE_PUSHED_USER`
    `static int` | `PRINTER_ATTRIBUTE_QUEUED`
    `static int` | `PRINTER_ATTRIBUTE_RAW_ONLY`
    `static int` | `PRINTER_ATTRIBUTE_SHARED`
    `static int` | `PRINTER_ATTRIBUTE_TS`
    `static int` | `PRINTER_ATTRIBUTE_TS_GENERIC_DRIVER`
    `static int` | `PRINTER_ATTRIBUTE_WORK_OFFLINE`
    `static int` | `PRINTER_CHANGE_ADD_FORM`
    `static int` | `PRINTER_CHANGE_ADD_JOB`
    `static int` | `PRINTER_CHANGE_ADD_PORT`
    `static int` | `PRINTER_CHANGE_ADD_PRINT_PROCESSOR`
    `static int` | `PRINTER_CHANGE_ADD_PRINTER`
    `static int` | `PRINTER_CHANGE_ADD_PRINTER_DRIVER`
    `static int` | `PRINTER_CHANGE_ALL`
    `static int` | `PRINTER_CHANGE_ALL_WIN7`
    `static int` | `PRINTER_CHANGE_CONFIGURE_PORT`
    `static int` | `PRINTER_CHANGE_DELETE_FORM`
    `static int` | `PRINTER_CHANGE_DELETE_JOB`
    `static int` | `PRINTER_CHANGE_DELETE_PORT`
    `static int` | `PRINTER_CHANGE_DELETE_PRINT_PROCESSOR`
    `static int` | `PRINTER_CHANGE_DELETE_PRINTER`
    `static int` | `PRINTER_CHANGE_DELETE_PRINTER_DRIVER`
    `static int` | `PRINTER_CHANGE_FAILED_CONNECTION_PRINTER`
    `static int` | `PRINTER_CHANGE_FORM`
    `static int` | `PRINTER_CHANGE_JOB`
    `static int` | `PRINTER_CHANGE_PORT`
    `static int` | `PRINTER_CHANGE_PRINT_PROCESSOR`
    `static int` | `PRINTER_CHANGE_PRINTER`
    `static int` | `PRINTER_CHANGE_PRINTER_DRIVER`
    `static int` | `PRINTER_CHANGE_SERVER`
    `static int` | `PRINTER_CHANGE_SET_FORM`
    `static int` | `PRINTER_CHANGE_SET_JOB`
    `static int` | `PRINTER_CHANGE_SET_PRINTER`
    `static int` | `PRINTER_CHANGE_SET_PRINTER_DRIVER`
    `static int` | `PRINTER_CHANGE_TIMEOUT`
    `static int` | `PRINTER_CHANGE_WRITE_JOB`
    `static int` | `PRINTER_ENUM_CONNECTIONS`
    `static int` | `PRINTER_ENUM_CONTAINER`
    `static int` | `PRINTER_ENUM_DEFAULT`
    `static int` | `PRINTER_ENUM_EXPAND`
    `static int` | `PRINTER_ENUM_FAVORITE`
    `static int` | `PRINTER_ENUM_HIDE`
    `static int` | `PRINTER_ENUM_ICON1`
    `static int` | `PRINTER_ENUM_ICON2`
    `static int` | `PRINTER_ENUM_ICON3`
    `static int` | `PRINTER_ENUM_ICON4`
    `static int` | `PRINTER_ENUM_ICON5`
    `static int` | `PRINTER_ENUM_ICON6`
    `static int` | `PRINTER_ENUM_ICON7`
    `static int` | `PRINTER_ENUM_ICON8`
    `static int` | `PRINTER_ENUM_ICONMASK`
    `static int` | `PRINTER_ENUM_LOCAL`
    `static int` | `PRINTER_ENUM_NAME`
    `static int` | `PRINTER_ENUM_NETWORK`
    `static int` | `PRINTER_ENUM_REMOTE`
    `static int` | `PRINTER_ENUM_SHARED`
    `static int` | `PRINTER_STATUS_BUSY`
    `static int` | `PRINTER_STATUS_DOOR_OPEN`
    `static int` | `PRINTER_STATUS_ERROR`
    `static int` | `PRINTER_STATUS_INITIALIZING`
    `static int` | `PRINTER_STATUS_IO_ACTIVE`
    `static int` | `PRINTER_STATUS_MANUAL_FEED`
    `static int` | `PRINTER_STATUS_NO_TONER`
    `static int` | `PRINTER_STATUS_NOT_AVAILABLE`
    `static int` | `PRINTER_STATUS_OFFLINE`
    `static int` | `PRINTER_STATUS_OUT_OF_MEMORY`
    `static int` | `PRINTER_STATUS_OUTPUT_BIN_FULL`
    `static int` | `PRINTER_STATUS_PAGE_PUNT`
    `static int` | `PRINTER_STATUS_PAPER_JAM`
    `static int` | `PRINTER_STATUS_PAPER_OUT`
    `static int` | `PRINTER_STATUS_PAPER_PROBLEM`
    `static int` | `PRINTER_STATUS_PAUSED`
    `static int` | `PRINTER_STATUS_PENDING_DELETION`
    `static int` | `PRINTER_STATUS_POWER_SAVE`
    `static int` | `PRINTER_STATUS_PRINTING`
    `static int` | `PRINTER_STATUS_PROCESSING`
    `static int` | `PRINTER_STATUS_SERVER_UNKNOWN`
    `static int` | `PRINTER_STATUS_TONER_LOW`
    `static int` | `PRINTER_STATUS_USER_INTERVENTION`
    `static int` | `PRINTER_STATUS_WAITING`
    `static int` | `PRINTER_STATUS_WARMING_UP`

    - ### Fields inherited from interface com.sun.jna.win32.StdCallLibrary

      `FUNCTION_MAPPER, STDCALL_CONVENTION`

    - ### Fields inherited from interface com.sun.jna.Library

      `OPTION_ALLOW_OBJECTS, OPTION_CALLING_CONVENTION, OPTION_CLASSLOADER, OPTION_FUNCTION_MAPPER, OPTION_INVOCATION_MAPPER, OPTION_OPEN_FLAGS, OPTION_STRING_ENCODING, OPTION_STRUCTURE_ALIGNMENT, OPTION_TYPE_MAPPER`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `ClosePrinter(WinNT.HANDLE hPrinter)` The ClosePrinter function closes the specified printer object. Note This is a blocking or synchronous function and might not return immediately. How quickly this function returns depends on run-time factors such as network status, print server configuration, and printer driver implementation-factors that are difficult to predict when writing an application.
    `boolean` | `EnumJobs(WinNT.HANDLE hPrinter, int FirstJob, int NoJobs, int Level, Pointer pJob, int cbBuf, IntByReference pcbNeeded, IntByReference pcReturned)` The EnumJobs function retrieves information about a specified set of print jobs for a specified printer.
    `boolean` | `EnumPrinters(int Flags, java.lang.String Name, int Level, Pointer pPrinterEnum, int cbBuf, IntByReference pcbNeeded, IntByReference pcReturned)` The EnumPrinters function enumerates available printers, print servers, domains, or print providers.
    `boolean` | `FindClosePrinterChangeNotification(WinNT.HANDLE hChange)` The FindClosePrinterChangeNotification function closes a change notification object created by calling the FindFirstPrinterChangeNotification function.
    `WinNT.HANDLE` | `FindFirstPrinterChangeNotification(WinNT.HANDLE hPrinter, int fdwFilter, int fdwOptions, WinDef.LPVOID pPrinterNotifyOptions)` The FindFirstPrinterChangeNotification function creates a change notification object and returns a handle to the object.
    `boolean` | `FindNextPrinterChangeNotification(WinNT.HANDLE hChange, WinDef.DWORDByReference pdwChange, WinDef.LPVOID pPrinterNotifyOptions, WinDef.LPVOID ppPrinterNotifyInfo)` The FindNextPrinterChangeNotification function retrieves information about the most recent change notification for a change notification object associated with a printer or print server.
    `boolean` | `GetPrinter(WinNT.HANDLE hPrinter, int Level, Pointer pPrinter, int cbBuf, IntByReference pcbNeeded)` The GetPrinter function retrieves information about a specified printer.
    `boolean` | `OpenPrinter(java.lang.String pPrinterName, WinNT.HANDLEByReference phPrinter, Winspool.LPPRINTER_DEFAULTS pDefault)` The OpenPrinter function retrieves a handle to the specified printer or print server or other types of handles in the print subsystem.

- - ### Field Detail

    - #### INSTANCE

          static final Winspool INSTANCE

    - #### CCHDEVICENAME

          static final int CCHDEVICENAME

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_PAUSED

          static final int PRINTER_STATUS_PAUSED

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_ERROR

          static final int PRINTER_STATUS_ERROR

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_PENDING_DELETION

          static final int PRINTER_STATUS_PENDING_DELETION

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_PAPER_JAM

          static final int PRINTER_STATUS_PAPER_JAM

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_PAPER_OUT

          static final int PRINTER_STATUS_PAPER_OUT

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_MANUAL_FEED

          static final int PRINTER_STATUS_MANUAL_FEED

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_PAPER_PROBLEM

          static final int PRINTER_STATUS_PAPER_PROBLEM

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_OFFLINE

          static final int PRINTER_STATUS_OFFLINE

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_IO_ACTIVE

          static final int PRINTER_STATUS_IO_ACTIVE

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_BUSY

          static final int PRINTER_STATUS_BUSY

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_PRINTING

          static final int PRINTER_STATUS_PRINTING

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_OUTPUT_BIN_FULL

          static final int PRINTER_STATUS_OUTPUT_BIN_FULL

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_NOT_AVAILABLE

          static final int PRINTER_STATUS_NOT_AVAILABLE

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_WAITING

          static final int PRINTER_STATUS_WAITING

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_PROCESSING

          static final int PRINTER_STATUS_PROCESSING

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_INITIALIZING

          static final int PRINTER_STATUS_INITIALIZING

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_WARMING_UP

          static final int PRINTER_STATUS_WARMING_UP

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_TONER_LOW

          static final int PRINTER_STATUS_TONER_LOW

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_NO_TONER

          static final int PRINTER_STATUS_NO_TONER

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_PAGE_PUNT

          static final int PRINTER_STATUS_PAGE_PUNT

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_USER_INTERVENTION

          static final int PRINTER_STATUS_USER_INTERVENTION

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_OUT_OF_MEMORY

          static final int PRINTER_STATUS_OUT_OF_MEMORY

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_DOOR_OPEN

          static final int PRINTER_STATUS_DOOR_OPEN

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_SERVER_UNKNOWN

          static final int PRINTER_STATUS_SERVER_UNKNOWN

      See Also:
        Constant Field Values

    - #### PRINTER_STATUS_POWER_SAVE

          static final int PRINTER_STATUS_POWER_SAVE

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_QUEUED

          static final int PRINTER_ATTRIBUTE_QUEUED

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_DIRECT

          static final int PRINTER_ATTRIBUTE_DIRECT

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_DEFAULT

          static final int PRINTER_ATTRIBUTE_DEFAULT

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_SHARED

          static final int PRINTER_ATTRIBUTE_SHARED

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_NETWORK

          static final int PRINTER_ATTRIBUTE_NETWORK

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_HIDDEN

          static final int PRINTER_ATTRIBUTE_HIDDEN

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_LOCAL

          static final int PRINTER_ATTRIBUTE_LOCAL

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_ENABLE_DEVQ

          static final int PRINTER_ATTRIBUTE_ENABLE_DEVQ

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_KEEPPRINTEDJOBS

          static final int PRINTER_ATTRIBUTE_KEEPPRINTEDJOBS

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_DO_COMPLETE_FIRST

          static final int PRINTER_ATTRIBUTE_DO_COMPLETE_FIRST

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_WORK_OFFLINE

          static final int PRINTER_ATTRIBUTE_WORK_OFFLINE

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_ENABLE_BIDI

          static final int PRINTER_ATTRIBUTE_ENABLE_BIDI

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_RAW_ONLY

          static final int PRINTER_ATTRIBUTE_RAW_ONLY

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_PUBLISHED

          static final int PRINTER_ATTRIBUTE_PUBLISHED

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_FAX

          static final int PRINTER_ATTRIBUTE_FAX

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_TS

          static final int PRINTER_ATTRIBUTE_TS

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_PUSHED_USER

          static final int PRINTER_ATTRIBUTE_PUSHED_USER

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_PUSHED_MACHINE

          static final int PRINTER_ATTRIBUTE_PUSHED_MACHINE

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_MACHINE

          static final int PRINTER_ATTRIBUTE_MACHINE

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_FRIENDLY_NAME

          static final int PRINTER_ATTRIBUTE_FRIENDLY_NAME

      See Also:
        Constant Field Values

    - #### PRINTER_ATTRIBUTE_TS_GENERIC_DRIVER

          static final int PRINTER_ATTRIBUTE_TS_GENERIC_DRIVER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_ADD_PRINTER

          static final int PRINTER_CHANGE_ADD_PRINTER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_SET_PRINTER

          static final int PRINTER_CHANGE_SET_PRINTER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_DELETE_PRINTER

          static final int PRINTER_CHANGE_DELETE_PRINTER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_FAILED_CONNECTION_PRINTER

          static final int PRINTER_CHANGE_FAILED_CONNECTION_PRINTER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_PRINTER

          static final int PRINTER_CHANGE_PRINTER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_ADD_JOB

          static final int PRINTER_CHANGE_ADD_JOB

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_SET_JOB

          static final int PRINTER_CHANGE_SET_JOB

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_DELETE_JOB

          static final int PRINTER_CHANGE_DELETE_JOB

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_WRITE_JOB

          static final int PRINTER_CHANGE_WRITE_JOB

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_JOB

          static final int PRINTER_CHANGE_JOB

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_ADD_FORM

          static final int PRINTER_CHANGE_ADD_FORM

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_SET_FORM

          static final int PRINTER_CHANGE_SET_FORM

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_DELETE_FORM

          static final int PRINTER_CHANGE_DELETE_FORM

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_FORM

          static final int PRINTER_CHANGE_FORM

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_ADD_PORT

          static final int PRINTER_CHANGE_ADD_PORT

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_CONFIGURE_PORT

          static final int PRINTER_CHANGE_CONFIGURE_PORT

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_DELETE_PORT

          static final int PRINTER_CHANGE_DELETE_PORT

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_PORT

          static final int PRINTER_CHANGE_PORT

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_ADD_PRINT_PROCESSOR

          static final int PRINTER_CHANGE_ADD_PRINT_PROCESSOR

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_DELETE_PRINT_PROCESSOR

          static final int PRINTER_CHANGE_DELETE_PRINT_PROCESSOR

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_PRINT_PROCESSOR

          static final int PRINTER_CHANGE_PRINT_PROCESSOR

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_SERVER

          static final int PRINTER_CHANGE_SERVER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_ADD_PRINTER_DRIVER

          static final int PRINTER_CHANGE_ADD_PRINTER_DRIVER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_SET_PRINTER_DRIVER

          static final int PRINTER_CHANGE_SET_PRINTER_DRIVER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_DELETE_PRINTER_DRIVER

          static final int PRINTER_CHANGE_DELETE_PRINTER_DRIVER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_PRINTER_DRIVER

          static final int PRINTER_CHANGE_PRINTER_DRIVER

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_TIMEOUT

          static final int PRINTER_CHANGE_TIMEOUT

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_ALL_WIN7

          static final int PRINTER_CHANGE_ALL_WIN7

      See Also:
        Constant Field Values

    - #### PRINTER_CHANGE_ALL

          static final int PRINTER_CHANGE_ALL

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_DEFAULT

          static final int PRINTER_ENUM_DEFAULT

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_LOCAL

          static final int PRINTER_ENUM_LOCAL

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_CONNECTIONS

          static final int PRINTER_ENUM_CONNECTIONS

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_FAVORITE

          static final int PRINTER_ENUM_FAVORITE

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_NAME

          static final int PRINTER_ENUM_NAME

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_REMOTE

          static final int PRINTER_ENUM_REMOTE

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_SHARED

          static final int PRINTER_ENUM_SHARED

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_NETWORK

          static final int PRINTER_ENUM_NETWORK

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_EXPAND

          static final int PRINTER_ENUM_EXPAND

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_CONTAINER

          static final int PRINTER_ENUM_CONTAINER

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_ICONMASK

          static final int PRINTER_ENUM_ICONMASK

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_ICON1

          static final int PRINTER_ENUM_ICON1

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_ICON2

          static final int PRINTER_ENUM_ICON2

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_ICON3

          static final int PRINTER_ENUM_ICON3

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_ICON4

          static final int PRINTER_ENUM_ICON4

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_ICON5

          static final int PRINTER_ENUM_ICON5

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_ICON6

          static final int PRINTER_ENUM_ICON6

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_ICON7

          static final int PRINTER_ENUM_ICON7

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_ICON8

          static final int PRINTER_ENUM_ICON8

      See Also:
        Constant Field Values

    - #### PRINTER_ENUM_HIDE

          static final int PRINTER_ENUM_HIDE

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### EnumPrinters

          boolean EnumPrinters(int Flags,
                               java.lang.String Name,
                               int Level,
                               Pointer pPrinterEnum,
                               int cbBuf,
                               IntByReference pcbNeeded,
                               IntByReference pcReturned)

      The EnumPrinters function enumerates available printers, print servers, domains, or print providers.
      Parameters:
        `Flags` - The types of print objects that the function should enumerate.
        `Name` - If Level is 1, Flags contains PRINTER_ENUM_NAME, and Name is non-NULL, then Name is a pointer to a null-terminated string that specifies the name of the object to enumerate. This string can be the name of a server, a domain, or a print provider. If Level is 1, Flags contains PRINTER_ENUM_NAME, and Name is NULL, then the function enumerates the available print providers. If Level is 1, Flags contains PRINTER_ENUM_REMOTE, and Name is NULL, then the function enumerates the printers in the user's domain. If Level is 2 or 5,Name is a pointer to a null-terminated string that specifies the name of a server whose printers are to be enumerated. If this string is NULL, then the function enumerates the printers installed on the local computer. If Level is 4, Name should be NULL. The function always queries on the local computer. When Name is NULL, setting Flags to PRINTER_ENUM_LOCAL | PRINTER_ENUM_CONNECTIONS enumerates printers that are installed on the local machine. These printers include those that are physically attached to the local machine as well as remote printers to which it has a network connection. When Name is not NULL, setting Flags to PRINTER_ENUM_LOCAL | PRINTER_ENUM_NAME enumerates the local printers that are installed on the server Name.
        `Level` - The type of data structures pointed to by pPrinterEnum. Valid values are 1, 2, 4, and 5, which correspond to the PRINTER_INFO_1, PRINTER_INFO_2 , PRINTER_INFO_4, and PRINTER_INFO_5 data structures.
        `pPrinterEnum` - A pointer to a buffer that receives an array of PRINTER_INFO_1, PRINTER_INFO_2, PRINTER_INFO_4, or PRINTER_INFO_5 structures. Each structure contains data that describes an available print object. If Level is 1, the array contains PRINTER_INFO_1 structures. If Level is 2, the array contains PRINTER_INFO_2 structures. If Level is 4, the array contains PRINTER_INFO_4 structures. If Level is 5, the array contains PRINTER_INFO_5 structures. The buffer must be large enough to receive the array of data structures and any strings or other data to which the structure members point. If the buffer is too small, the pcbNeeded parameter returns the required buffer size.
        `cbBuf` - The size, in bytes, of the buffer pointed to by pPrinterEnum.
        `pcbNeeded` - A pointer to a value that receives the number of bytes copied if the function succeeds or the number of bytes required if cbBuf is too small.
        `pcReturned` - A pointer to a value that receives the number of PRINTER_INFO_1, PRINTER_INFO_2 , PRINTER_INFO_4, or PRINTER_INFO_5 structures that the function returns in the array to which pPrinterEnum points.
      Returns:
        If the function succeeds, the return value is a nonzero value. If the function fails, the return value is zero.
      See Also:
        EnumPrinters function

    - #### GetPrinter

          boolean GetPrinter(WinNT.HANDLE hPrinter,
                             int Level,
                             Pointer pPrinter,
                             int cbBuf,
                             IntByReference pcbNeeded)

      The GetPrinter function retrieves information about a specified printer.
      Parameters:
        `hPrinter` - A handle to the printer for which the function retrieves information. Use the OpenPrinter or AddPrinter function to retrieve a printer handle.
        `Level` - The level or type of structure that the function stores into the buffer pointed to by pPrinter. This value can be 1, 2, 3, 4, 5, 6, 7, 8 or 9.
        `pPrinter` - A pointer to a buffer that receives a structure containing information about the specified printer. The buffer must be large enough to receive the structure and any strings or other data to which the structure members point. If the buffer is too small, the pcbNeeded parameter returns the required buffer size. The type of structure is determined by the value of Level.
        `cbBuf` - The size, in bytes, of the buffer pointed to by pPrinter.
        `pcbNeeded` - A pointer to a variable that the function sets to the size, in bytes, of the printer information. If cbBuf is smaller than this value, GetPrinter fails, and the value represents the required buffer size. If cbBuf is equal to or greater than this value, GetPrinter succeeds, and the value represents the number of bytes stored in the buffer.
      Returns:
        If the function succeeds, the return value is a nonzero value. If the function fails, the return value is zero.
      See Also:
        GetPrinter function

    - #### OpenPrinter

          boolean OpenPrinter(java.lang.String pPrinterName,
                              WinNT.HANDLEByReference phPrinter,
                              Winspool.LPPRINTER_DEFAULTS pDefault)

      The OpenPrinter function retrieves a handle to the specified printer or print server or other types of handles in the print subsystem.
      Parameters:
        `pPrinterName` - [in] A pointer to a null-terminated string that specifies the name of the printer or print server, the printer object, the XcvMonitor, or the XcvPort. For a printer object use: PrinterName, Job xxxx. For an XcvMonitor, use: ServerName, XcvMonitor MonitorName. For an XcvPort, use: ServerName, XcvPort PortName. If NULL, it indicates the local printer server.
        `phPrinter` - [out] A pointer to a variable that receives a handle (not thread safe) to the open printer or print server object. The phPrinter parameter can return an Xcv handle for use with the XcvData function. For more information about XcvData, see the DDK.
        `pDefault` - [in] A pointer to a PRINTER_DEFAULTS structure. This value can be NULL.
      Returns:
        If the function succeeds, the return value is a nonzero value. If the function fails, the return value is zero.
      See Also:
        OpenPrinter function

    - #### ClosePrinter

          boolean ClosePrinter(WinNT.HANDLE hPrinter)

      The ClosePrinter function closes the specified printer object.
      Note This is a blocking or synchronous function and might not return immediately.
      How quickly this function returns depends on run-time factors such as network status, print server configuration, and printer driver implementation-factors that are difficult to predict when writing an application. Calling this function from a thread that manages interaction with the user interface could make the application appear to be unresponsive. When the ClosePrinter function returns, the handle hPrinter is invalid, regardless of whether the function has succeeded or failed.
      Parameters:
        `hPrinter` - A handle to the printer object to be closed. This handle is returned by the OpenPrinter or AddPrinter function.
      Returns:
        If the function succeeds, the return value is a nonzero value. If the function fails, the return value is zero.
      See Also:
        ClosePrinter function

    - #### FindFirstPrinterChangeNotification

          WinNT.HANDLE FindFirstPrinterChangeNotification(WinNT.HANDLE hPrinter,
                                                          int fdwFilter,
                                                          int fdwOptions,
                                                          WinDef.LPVOID pPrinterNotifyOptions)

      The FindFirstPrinterChangeNotification function creates a change notification object and returns a handle to the object. You can then use this handle in a call to one of the wait functions to monitor changes to the printer or print server. The FindFirstPrinterChangeNotification call specifies the type of changes to be monitored. You can specify a set of conditions to monitor for changes, a set of printer information fields to monitor, or both. A wait operation on the change notification handle succeeds when one of the specified changes occurs in the specified printer or print server. You then call the FindNextPrinterChangeNotification function to retrieve information about the change, and to reset the change notification object for use in the next wait operation.
      Parameters:
        `hPrinter` - [in] A handle to the printer or print server that you want to monitor. Use the OpenPrinter or AddPrinter function to retrieve a printer handle.
        `fdwFilter` - The conditions that will cause the change notification object to enter a signaled state. A change notification occurs when one or more of the specified conditions are met. The fdwFilter parameter can be zero if pPrinterNotifyOptions is non-NULL.
        `fdwOptions` - Reserved; must be zero.
        `pPrinterNotifyOptions` - [in, optional] A pointer to a PRINTER_NOTIFY_OPTIONS structure. The pTypes member of this structure is an array of one or more PRINTER_NOTIFY_OPTIONS_TYPE structures, each of which specifies a printer information field to monitor. A change notification occurs when one or more of the specified fields changes. When a change occurs, the FindNextPrinterChangeNotification function can retrieve the new printer information. This parameter can be NULL if fdwFilter is nonzero. For a list of fields that can be monitored, see PRINTER_NOTIFY_OPTIONS_TYPE.
      Returns:
        If the function succeeds, the return value is a handle to a change notification object associated with the specified printer or print server. If the function fails, the return value is INVALID_HANDLE_VALUE.
      See Also:
        FindFirstPrinterChangeNotification function

    - #### FindNextPrinterChangeNotification

          boolean FindNextPrinterChangeNotification(WinNT.HANDLE hChange,
                                                    WinDef.DWORDByReference pdwChange,
                                                    WinDef.LPVOID pPrinterNotifyOptions,
                                                    WinDef.LPVOID ppPrinterNotifyInfo)

      The FindNextPrinterChangeNotification function retrieves information about the most recent change notification for a change notification object associated with a printer or print server. Call this function when a wait operation on the change notification object is satisfied. The function also resets the change notification object to the not-signaled state. You can then use the object in another wait operation to continue monitoring the printer or print server. The operating system will set the object to the signaled state the next time one of a specified set of changes occurs to the printer or print server. The FindFirstPrinterChangeNotification function creates the change notification object and specifies the set of changes to be monitored.
      Parameters:
        `hChange` - [in] A handle to a change notification object associated with a printer or print server. You obtain such a handle by calling the FindFirstPrinterChangeNotification function. The operating system sets this change notification object to the signaled state when it detects one of the changes specified in the object's change notification filter.
        `pdwChange` - [out, optional] A pointer to a variable whose bits are set to indicate the changes that occurred to cause the most recent notification. The bit flags that might be set correspond to those specified in the fdwFilter parameter of the FindFirstPrinterChangeNotification call. The system sets one or more of the following bit flags.
        `pPrinterNotifyOptions` - [in, optional] A pointer to a PRINTER_NOTIFY_OPTIONS structure. Set the Flags member of this structure to PRINTER_NOTIFY_OPTIONS_REFRESH, to cause the function to return the current data for all monitored printer information fields. The function ignores all other members of the structure. This parameter can be NULL.
        `ppPrinterNotifyInfo` - [out, optional] A pointer to a pointer variable that receives a pointer to a system-allocated, read-only buffer. Call the FreePrinterNotifyInfo function to free the buffer when you are finished with it. This parameter can be NULL if no information is required. The buffer contains a PRINTER_NOTIFY_INFO structure, which contains an array of PRINTER_NOTIFY_INFO_DATA structures. Each element of the array contains information about one of the fields specified in the pPrinterNotifyOptions parameter of the FindFirstPrinterChangeNotification call. Typically, the function provides data only for the fields that changed to cause the most recent notification. However, if the structure pointed to by the pPrinterNotifyOptions parameter specifies PRINTER_NOTIFY_OPTIONS_REFRESH, the function provides data for all monitored fields. If the PRINTER_NOTIFY_INFO_DISCARDED bit is set in the Flags member of the PRINTER_NOTIFY_INFO structure, an overflow or error occurred, and notifications may have been lost. In this case, no additional notifications will be sent until you make a second FindNextPrinterChangeNotification call that specifies PRINTER_NOTIFY_OPTIONS_REFRESH.
      Returns:
        If the function succeeds, the return value is a nonzero value. If the function fails, the return value is zero.
      See Also:
        FindClosePrinterChangeNotification function

    - #### FindClosePrinterChangeNotification

          boolean FindClosePrinterChangeNotification(WinNT.HANDLE hChange)

      The FindClosePrinterChangeNotification function closes a change notification object created by calling the FindFirstPrinterChangeNotification function. The printer or print server associated with the change notification object will no longer be monitored by that object.
      Parameters:
        `hChange` - [in] A handle to the change notification object to be closed. This is a handle created by calling the FindFirstPrinterChangeNotification function.
      Returns:
        If the function succeeds, the return value is a nonzero value. If the function fails, the return value is zero.
      See Also:
        FindClosePrinterChangeNotification function

    - #### EnumJobs

          boolean EnumJobs(WinNT.HANDLE hPrinter,
                           int FirstJob,
                           int NoJobs,
                           int Level,
                           Pointer pJob,
                           int cbBuf,
                           IntByReference pcbNeeded,
                           IntByReference pcReturned)

      The EnumJobs function retrieves information about a specified set of print jobs for a specified printer.
      Parameters:
        `hPrinter` - A handle to the printer object whose print jobs the function enumerates. Use the OpenPrinter or AddPrinter function to retrieve a printer handle.
        `FirstJob` - The zero-based position within the print queue of the first print job to enumerate. For example, a value of 0 specifies that enumeration should begin at the first print job in the print queue; a value of 9 specifies that enumeration should begin at the tenth print job in the print queue.
        `NoJobs` - The total number of print jobs to enumerate.
        `Level` - The type of information returned in the pJob buffer.
        `pJob` - A pointer to a buffer that receives an array of JOB_INFO_1, JOB_INFO_2, or JOB_INFO_3 structures. The buffer must be large enough to receive the array of structures and any strings or other data to which the structure members point.
        `cbBuf` - The size, in bytes, of the pJob buffer.
        `pcbNeeded` - A pointer to a variable that receives the number of bytes copied if the function succeeds. If the function fails, the variable receives the number of bytes required.
        `pcReturned` - A pointer to a variable that receives the number of JOB_INFO_1, JOB_INFO_2, or JOB_INFO_3 structures returned in the pJob buffer.
      Returns:
        If the function succeeds, the return value is a nonzero value. If the function fails, the return value is zero.
      See Also:
        EnumJobs function

Copyright © 2007-2016 Timothy Wall. All Rights Reserved.